# Opens a file, reads the file one line at a time,
# searching for data from the user.
# Ignores anything after the '#' sign
# by CS111

# Make a constant so easy to change if what signifies a commented line
# changes.
COMMENT = "#"

inputfile = "data/years3.dat"

searchTerm = raw_input("What are you looking for? ")

# opens the file in "read" mode
dataFile = file(inputfile, "r")

# set up accumulators
lineNum = 0
numOccurrences = 0

# reads in the file and prints the content of the file
for line in dataFile:
    lineNum+=1

    # removes the trailing and beginning whitespace
    line = line.strip()
    
    # only do the find if we know that the comment is in the
    # string
    if COMMENT in line:
        # the position of the comment in the string
        commentPos = line.find(COMMENT)
        # get only what's after the comment
        line = line[:commentPos]

    # look for the searchTerm in the line
    if searchTerm in line:
        print "Found %s in line %d: \"%s\"" % (searchTerm, lineNum, line)
        numOccurrences+=1

# close the file with the method "close"
dataFile.close()

# Report findings ...
print searchTerm, "was found", numOccurrences, "times"
