# Read in majors from a file and put into a dictionary
# that maps the major to how many students have that major.
# by Sara Sprenkle

UNDECLARED="Undeclared"

def main():
    MAJORSFILE="data/majors.all.dat"

    majorsData = file(MAJORSFILE, "r")

    # create an empty dictionary that will map last names to majors

    majorToCount={}

    for line in majorsData:
        line = line.strip()

        # FIRST " " SPLITS NAME AND MAJORS

        spacePos = line.find(" ")
        if spacePos== -1:
            # person is undeclared
            addStudent( majorToCount )
        else:     
            name = line[:spacePos]
            # print "name=", name
            major = line[spacePos+1:]
            # print "major=", major

            addStudent( majorToCount, major)

    majorsData.close()

    printMajorInfo(majorToCount)

# Update the mapping of majors to number of majors.
# Input: dictionary of majors to number of majors (majorToCount),
# and optional string major (defaults to Undeclared)
def addStudent(majorToCount, major=UNDECLARED):
    if majorToCount.get(major) != None:
        majorToCount[major]+=1
    else:
        majorToCount[major]=1

# Print the number of majors for each major, sorting
# alphabetically by the major
# Input: mapping of majors to the number of majors
def printMajorInfo(majorToCount):
    # not actually sorted at this point
    sortedKeys = majorToCount.keys()
    sortedKeys.sort()

    print "%25s %5s" %( "MAJOR", "NUM")
    print "-"*31
    for major in sortedKeys:
        count = majorToCount[major]
        print "%25s %5d" % (major, count)



main()
