# Read in years from a file and put into a dictionary that maps years to number
# of students in that year.
# Also provides an example of modifying a dictionary, passed as a parameter.
# CS111


def main():
    YEARSFILE="data/years.dat"
    
    yearsData = file(YEARSFILE, "r")
    
    # create an empty dictionary that will map last names to years
    
    yearToCount={}
    
    for line in yearsData:
        line = line.strip()
    
        # FIRST " " SPLITS NAME AND YEARS
        
        spacePos = line.find(" ")
        if spacePos== -1:
            print "Error: no name/year pair in line:", line
        else:     
            name = line[:spacePos]
            # print "name=", name
            year = line[spacePos+1:]
            # print "year=", year
    
            updateFreq(yearToCount, year)
            
    
    yearsData.close()
    
    # print the information nicely
    for year in yearToCount:
        count = yearToCount[year]
        if count > 1:
            print "There are", count, year + "s."
        else:
            print "There is 1", year + "s."


# Update the mapping in the dictionary for the
# frequency of the key
def updateFreq( dictionary, key ):
    if dictionary.get(key) != None:
        dictionary[key]+=1
    else:
        dictionary[key]=1
        
main()
