class Card:
    """
    A class to represent a standard playing card. The ranks are ints:
    2-10 for numbered cards, 11=Jack, 12=Queen, 13=King, 14=Ace.
    The suits are strings: 'clubs', 'spades', 'hearts', 'diamonds'.
    """
    
    def __init__(self, rank, suit):
        "Constructor for class Card takes int rank and string suit."
        self.rank = rank
        self.suit = suit

    def __str__(self):
        "Returns a string describing the card as 'rank of suit'."
        result = ""
        if self.rank == 11:
            result += "Jack"
        elif self.rank == 12:
            result += "Queen"
        elif self.rank == 13:
            result += "King"
        elif self.rank == 14:
            result += "Ace"
        else:
            result += str(self.rank)
        result += " of " + self.suit
        return result

    def getRank(self):
	"Returns rank."	
        return self.rank

    def getSuit(self):
        "Returns suit."
        return self.suit

    def blackJackValue(self):
        if self.rank == 14:
            return 1
        elif self.rank > 10:
            return 10
        else:
            return self.rank

    def rummyValue(self):
        if self.rank == 14:
            return 15
        elif self.rank > 10:
            return 10
        else:
            return 5
    
    def __cmp__(self, other):
        """ Compares Card objects by their ranks """
        # Could compare by black jack value or rummy value
        #print self, other
        if self.rank < other.getRank():
            #print "less"
            return -1
        elif self.rank > other.getRank():
            #print "greater"
            return 1
        else:
            return 0
        

def main():
    c3 = Card(3, "hearts")
    print "c1 =", c3
    c2 = Card(13, "hearts")
    print "c2 =", c2
    c1 = Card(3, "spades")
    print "c3 =", c1
    
    print "\nTest _cmp_ method..."
    print c1, "__cmp__", c2, "-->", c1.__cmp__(c2)
    print c3, "__cmp__", c1, "-->", cmp(c3,c1)
    
    #If you don't define a __cmp__ method, then the default behavior is to
    # compare memory addresses.
    
    print c1,">",c2,"?", c1 > c2
    print c1,">",c3,"?", c1 > c3
    print c2, ">", c3, "?", c2 > c3
    
if __name__ == '__main__':
    main()
