<!--Template adapted from www.oswd.org.  "Sinorca" template originally designed by haran-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en-AU">
  <head>
    <meta http-equiv="content-type" content="application/xhtml+xml; charset=UTF-8" />
    
	<title>CS 111: Fundamentals of Programming I</title>
        <link rel="stylesheet" type="text/css" href="course.css" />

</head>

  <body>
 <? include("header.php"); ?>
 <? include("sidebar.php"); ?>

  <div class="rightcontainer">
  <div class="rightbox">
  <h2>Announcements</h2>
  <ul>
  <li>Lab is due on Friday
   <li>Post your blog entry about the reading by Friday at 10 a.m.
  </ul>
  </div>

  </div>

    <!-- ##### Main Copy ##### -->

    <div id="main-copy">

      <h1 id="overview">Course Overview</h1>
      
<p>
Welcome to CS 111, Fundamentals of Programming I!  In this course,
you'll do more than just computer programming: you'll learn the
fundamental problem-solving ideas in computer science. 
</p>

<p>
This course is appropriate for all students who want to learn how to
write computer programs and think like computer scientists. It is the
usual first course for computer science majors.   A deeper
coverage of these topics will be presented in <a href="http://www.cs.wlu.edu/courses/cs112">CS 112</a>.
 
</p>

 <h2>Course Description</h2>

<p>
This course will cover

<ul>
<li>the design and implementation of algorithms for solving problems

<li>an introduction to syntax, semantics, and pragmatics of the <a
href="http://www.python.org/">Python</a> programming language, an
interpreted language known for its ease of use

<li>a survey of programming applications such as numerical computation,
text processing, graphics, image processing, and networking

<li>an introduction to the use of the <a href="http://www.linux.org/">Linux operating system</a>

<li>systematic techniques for testing and debugging programs

</ul>
</p>

      <p><strong>Structure</strong><br />
      
      Classroom work will consist of lecture, discussion, and lab
experimentation. Written work will consist of weekly programming
projects, several exams, and weekly analyses of articles about
CS-related issues. </p>

  <p>
    <strong>Lecture:</strong> MWF 1:25 p.m. - 2:20 p.m. in Parmly 307 <br/>
    <strong>Lab:</strong> T 2:30 p.m. - 5:35 p.m. in Parmly 405</span>
    </p>

      <p> <strong>Objectives</strong><br />

      After taking this course, you should be able to

<ul>

  <li>Apply your problem-solving skills and knowledge of data structures to
  a wide variety of computational problems

  <li>Understand the fundamentals of the syntax and semantics of <a
  href="http://www.python.org/">Python</a> programming language

  <li>Describe a program's functionality in plain English, typically using comments

  <li>Expose, diagnose, and fix errors in a program, using systematic
  testing and debugging techniques

  <li>Understand the fundamentals of using the UNIX operating system

  <li>Understand the design issues of computer science, including the
  tradeoffs in efficiency, as well as larger social and political issues and
  impacts, such as the digital divide, green computing, ethics and policies.


</ul>

</p>


      <h2>Instructional Staff</h2>
      <p>
<a href="http://www.cs.wlu.edu/~sprenkle">Sara Sprenkle</a><br />
Office: Parmly Hall 410<br />
Office Hours: Wednesday 2:30-4:30 p.m., Thursday 1:30-3:30 p.m., or by appointment<br />
E-mail Address: <script language=javascript>
<!--
var username = "sprenkles";
var hostname = "wlu.edu";
var linktext = "<img src=email.jpg>";
document.write("<a href=" + "mail" + "to:" + username + "@" + hostname + ">" + linktext + "</a>")
//--> 
</script>
<br />
Phone Number: (540) 458-8309  (it is better to email me than to call)

<p>
  <b>Student Assistants:</b> Ethan Smith and Anne Van Devender
</p>

    <h2>Course Information </h2>

		<h3>Textbook</h3>

		<p>
		
		<i><a
		href="http://home.wlu.edu/~lambertk/pythonbook">An
		Introduction to Computer Science with Python</a></i>
		by Dr. Lambert is available online to students in this
		course under password protection.  Ask Professor
		Sprenkle if you haven't received the password.</p>

    <h3 id="policies">Course Policies </h3>
        <p><strong>Student Responsibilities</strong>
	<ul>

      <li>It is very important that you attend lectures (see Grading
    below). There will be considerable information given in class that
    is not available elsewhere.

					<p>Attendance in lab is required.  We schedule the labs for your benefit so that you can practice with three people available for assistance.  If you do not attend or leave early, you will only get limited help.  Therefore, you should make the most of lab time.
    Family and medical emergencies and conflicts with
    University-recognized extra-curricular activities are the only
    reasons to request that work be rescheduled.  If you must miss a
    lab for some reason, make arrangements for a make-up session in
    advance.  


     <li>You are expected to arrive at labs and
    lectures promptly. 

     <li>Please turn off cellphones.

    <li>Actively participate in the class by asking and answering questions.

    <li>Check your W &amp; L email frequently and
     check this web page and the schedule for new information.

    <li>Throughout this class (and life in general), keep in mind a 
cowboy's wisdom:
     <b>"Good judgement comes from experience."</b>
     You may ask, "How do I get experience?"  <b>Bad judgement works every time.</b>
     My point?  Don't be afraid to make mistakes in this class,
     but make sure you learn from them!
   </ul>


        <p><strong>Instructor Responsibilities</strong><br /> I will try to
        make this course and its material as exciting for you as it is for
        me. I will be respectful of student questions and misunderstandings.
        I will give prompt, constructive feedback from assignments. I will
        be available during office hours and by appointment. I will do my
        best to respond to questions via email within 24 hours. </p>
        
  <p><strong>Honor System</strong><br/>

	You may discuss programming assignments informally with other students.
	However, sharing a solution, in the form of experimental results or the
	design or implementation of a program, is an honor violation. Students
	should know where to draw the line between getting legitimate outside
	assistance with course material and outright cheating. Students who obtain
	too much assistance without learning the material ultimately cheat
	themselves the most. <b>If you have any uncertainty about what this means,
	consult with me before you collaborate.</b> All written assignments should
	be done individually.

<!--
Programming projects, homework exercises, and exams should be written
individually. The standard rules for citing the work of others apply
to all your written work.-->


	<p><strong>Participation and attendance</strong><br/> To receive full
	credit for class participation and attendance, you must have less than
	three unexcused absences from lecture and lab and you must be actively
	engaged in the classroom by answering and asking questions each class when
	appropriate and by being respectful of other students. The average grade
	for participation is a B.

<!--	<p>You are permitted three "sick days" for minor illnesses
	and one "personal day" which you may use for any reason (e.g.,
	family occasion).  No documentation is needed or requested for
	these absences.  Unexcused absences beyond these will result
	in deduction in your participation grade.  Excused university
	absences (e.g., for intercollegiate athletics, documented by a
	note from a faculty or staff member) do not count towards your
	sick days or personal days.
	</p>
-->

	<p>The schedule, including important dates, is posted at the 
	beginning of the semester.  You should plan accordingly.  If
	there are acceptable conflicts, tell me at the beginning of the 
	semester and then remind me about a week in advance.
	</p>

	<p><strong>General grading policies</strong> <br/> 
         Programs
	 turned in with syntax errors will receive no credit.  "Roll
	 back" your program (often by commenting out the new trouble
	 spots) into a state where it does not have syntax errors.
	 </p>

	<p><strong>Late policy</strong><br/> All assigned work is due on
	the date specified. Any assignment turned in after the due
	date/time but on the same day will be penalized 10%. Any
	assignment turned in after the day on which it is due will be
	penalized 50% of the total value for that assignment. No
	assignment will be accepted that is more than three school
	days late. If you turn an assignment in late, you must
	indicate this on the top of the paper.  

			     <p>Extensions are rarely granted.  You have three hours in lab to complete the assignment with help from the instructor and student assistants, plus a few days to finish up if you need more time.  If you leave lab before the period is over, you will not be granted an extension for any reason.


        <h3 id="grading">Grading</h3>

	<p>Grades for the course will be computed as follows:
	
	<ul>
	<li> Programming projects (40% of the grade)
	<li>Two hourly exams (30% of the grade)
	<li> A comprehensive final exam (20% of the grade) 

        <li>Writeups and discussions of
        <a href="csissues.php">CS-related issues</a> (5% of the grade)

	<li>Participation and attendance (5% of the grade)
	</ul>

  </div>

    <!-- ##### Footer ##### -->

    <div id="footer"><span class="footer">&copy;Creative Commons,</span> 2008 </div>
  </body>
</html>
